# Filters added to this controller apply to all controllers in the application.
# Likewise, all the methods added will be available for all controllers.

class ApplicationController < ActionController::Base
  # Pick a unique cookie name to distinguish our session data from others'
  session :session_key => '_bugle_session_id'
end

# Login system
# see http://wiki.rubyonrails.com/rails/pages/HowToQuicklyDoAuthenticationWithLoginGenerator
require 'login_system'

class ApplicationController < ActionController::Base
    include LoginSystem
    model :user
end

# use the YUI calendar control.
module ActionView; module Helpers; module DateHelper;
  # General plan is to insert the YUI control and then have JavaScript use input_hiddens when the submit button is clicked.
  def date_select controller, field, opts = {}
    if opts[:default].is_a? Hash
      now = Date.today
      d = {:year => now.year, :month => now.month, :day => now.day}.merge(opts[:default])
      opts[:default] = Date.civil(d[:year], d[:month], d[:day])  #d[:day] :-)
    end

    selected_date = opts[:default] || Date.today
    js_date = selected_date.strftime("%m/%d/%Y") # mm/dd/yyyy
    ret = ""
    cal_id = "#{controller}_#{field}"
    # Where date_select is called, we need to insert a DIV where the calendar will go.
    ret << "<div id=\"#{cal_id}Container\" class=\"yui-skin-sam\"></div>"
    
    # Then we need some JS to load the calendar
    ret << <<-EOT
      <script>
        YAHOO.namespace("#{cal_id}.calendar");
        
        YAHOO.#{cal_id}.calendar.init = function()
        {
          YAHOO.#{cal_id}.calendar.#{cal_id} = new YAHOO.widget.Calendar("#{cal_id}","#{cal_id}Container");
          YAHOO.#{cal_id}.calendar.#{cal_id}.select("#{js_date}");
          YAHOO.#{cal_id}.calendar.#{cal_id}.setMonth(#{selected_date.month - 1})
          YAHOO.#{cal_id}.calendar.#{cal_id}.setYear(#{selected_date.year})
          YAHOO.#{cal_id}.calendar.#{cal_id}.render();
        }
        YAHOO.util.Event.onDOMReady(YAHOO.#{cal_id}.calendar.init);
	</script>
    EOT
    
    # And some JS that will transform the calendar into <input type="hidden">s on page unload.
    ret << <<-EOT
      <script>
        YAHOO.#{cal_id}.calendar.unloader = function()
        {
          // Get all the info out of the calendar.
          var cal = YAHOO.#{cal_id}.calendar.#{cal_id};
          var date = cal.getSelectedDates()[0];
          var day = date.getDate();
          var month = date.getMonth() + 1; // JavaScript month is 0=January, Ruby version is 1=January.
          var year = date.getFullYear();
          
          // Now make our <input type="hidden">s.
          var day_field = document.createElement("input");
          day_field.setAttribute("id", "#{cal_id}_3i");
          day_field.setAttribute("type", "hidden");
          day_field.setAttribute("name", "#{controller}[#{field}(3i)]");
          day_field.setAttribute("value", day);
          
          var month_field = document.createElement("input");
          month_field.setAttribute("id", "#{cal_id}_2i");
          month_field.setAttribute("type", "hidden");
          month_field.setAttribute("name", "#{controller}[#{field}(2i)]");
          month_field.setAttribute("value", month);

          var year_field = document.createElement("input");
          year_field.setAttribute("id", "#{cal_id}_1i");
          year_field.setAttribute("type", "hidden");
          year_field.setAttribute("name", "#{controller}[#{field}(1i)]");
          year_field.setAttribute("value", year);
          
          var form = document.getElementsByTagName("form")[0]
          form.appendChild(day_field);
          form.appendChild(month_field);
          form.appendChild(year_field);
        }
        // Register the onclick function once the DOM is ready.
        YAHOO.util.Event.onDOMReady(function()
        {
          var submit_button = null;
          var inputs = document.getElementsByTagName("input");
          for (var i = 0; i < inputs.length; i++)
          {
            if (inputs[i].getAttribute("type") == "submit")
              submit_button = inputs[i];
          }
          YAHOO.util.Event.addListener(submit_button, "click", YAHOO.#{cal_id}.calendar.unloader);
        });
      </script>
    EOT
    
    return ret
  end
end;end;end;
