class Migration < ActiveRecord::Migration
  def self.up
    # integer, float, datetime, date, timestamp, time, text, string, binary, and boolean
    create_table :announcements do |t|
      t.column :creator, :string, :null => false
      t.column :creation_date, :date, :null => false
      t.column :start_date, :date, :null => false
      t.column :start_time, :string, :null => false # Could be enum of morning, afternoon.
      t.column :end_date, :date, :null => false
      t.column :end_time, :string, :null => false
      t.column :text, :text, :null => false
      t.column :approved, :boolean, :null => false
    end
    
    create_table :users do |t|
      t.column :login, :string, :null => false
      t.column :password, :string, :null => false
      t.column :roles, :string, :default => ''
    end
  end

  def self.down
    drop_table :users
    drop_table :announcements
  end
end
